#!/bin/bash
# $Revision: 1.2 $
# STANDARD 1.0
# PLUGIN TYPE:LIST
# PLUGIN LIST:irc.platinumirc.org #paradiso

######################################################################
echo "BEGIN: $(basename $0) $*" >&2
######################################################################
# Questo e' un "bash script plugin" per BuDuScRiPt/budus_xdcc.sh

# Il suo scopo e' quello di fornire un "motore di ricerca".

######################################################################
# Include la Libreria di Funzioni XDCC
source $(dirname ${0})/budus_XBSPSE_LIB.sh

######################################################################
# Lo script "budus_xdcc.sh" invoca questo script passando, come primo
# parametro, un codice casuale che serve per calcolare il file dentro
# al quale immagazzinare il risultato opportunamente filtrato.
RANDOM_NUMBER=${1}

# Il secondo parametro e' il numero di secondi d'attesa del risultato
# dal sito web interrogato, trascorsi i quali, si deve interrompere la
# ricerca del plugin.
WGET_TIMEOUT=${2}

# Il terzo parametro rappresenta la "stringa di ricerca" immessa
# dall'utente.
SEARCH_STRING=${3}

######################################################################
# VARIABILI AD USO DEL FILTRO
######################################################################
db_url_1="http://paradiso.platinumirc.net/lista1/index.php"
db_url_2="http://paradiso.platinumirc.net/lista2/index.php"
wget_option="-q -t 1 -O - -T ${WGET_TIMEOUT}"

######################################################################
# Vengono create e inizializzate le variabili base operative.
make_plugin_variables "${0}"

######################################################################
# Questo plugin, scaricando una lista anziche' interrogando un motore
# di ricerca web, lavore in modo diverso: salva il risultato
# "giornaliero" (cioe' lo aggiorna solo una volta al giorno)
if [ -f /tmp/budus_XDCC_db_${plugin_name}.${date_code} ]; then
    make_data_file_exchange

    rm -f ${plugin_tempfile}    
    echo "END  : $(basename $0) $*" >&2
    exit 0;
else
    rm -f /tmp/budus_XDCC_db_${plugin_name}.*
fi

######################################################################
wget ${wget_option} ${db_url_1}   | sed 's/\r//g'  > ${plugin_tempfile}
wget ${wget_option} ${db_url_2}   | sed 's/\r//g' >> ${plugin_tempfile}
cp -f ${plugin_tempfile} /tmp/budus_XDCC_db_${plugin_name}.dat

######################################################################
if [ ! -f "${plugin_tempfile}" ]; then
    echo > "${plugin_tempfile}"
    if [ ! -f "${plugin_tempfile}" ]; then
	echo "/ECHO %C4,1Non sono in grado di creare files temporanei in /tmp, problema di permessi ?"
	echo "/ECHO (${plugin_tempfile})"
	exit 1;
    else
	echo "/ECHO %C4,1Il plugin non e' stato in grado di generare il database. Segnalare il problema a UDA'Software, se persiste."
	exit 1;
    fi
fi

######################################################################
# Filtraggio
# L'output del filtro e' rappresentato da 8 campi separati dal
# carattere di tabulazione '\t', ovvero:
# NETWORK_NAME NETWORK_HOST CHANNEL BOT_NAME ID FILE_NAME SIZE COMMAND
#       1            2         3        4    5      6      7      8
######################################################################
filter_ONCLICK_Fantasy 'Platinumirc' 'irc.platinumirc.org' '#paradiso'
make_data_file_exchange

######################################################################
rm -f ${plugin_tempfile}

######################################################################
echo "END  : $(basename $0) $*" >&2
######################################################################