#!/bin/bash

# Version 23/12/2011
# $Revision: 1.5 $
# UDA'Software 2007

# Questo script serve per aggiungere una MACRO

read_macro_name() {
    clear
    cat<<EOF
********************************************************************************
NOME MACRO
DOMANDA : Come si deve chiamare la MACRO ?
SUGGER. : E' opportuno che il nome non contenga spazi, sia il piu'
          breve ma intuitivo e mnemonico possibile.

Inserire il nome della MACRO:
EOF
    read macro_name
    macro_name="${macro_name/\.[mM][cC][rR]$/}"
    macro_name="${macro_name//[^a-zA-Z0-9]/_}"
    if [ "${macro_name}" == "" ]; then
	echo "ERRORE: Non e' possibile specificare un Nome MACRO nullo."
	echo "Premi INVIO per continuare"
	read
	
	exit 1;
    fi
    if [ -f "${HOME}/.xchat2/buduscript/${macro_name}.mcr" ]; then
	echo "ERRORE: Non e' possibile specificare un Nome MACRO (${macro_name}) gia' esistente."
	echo "Premi INVIO per continuare"
	read
	
	exit 1;
    fi
}

read_editor() {
    clear
    if [ "$(nano --version)" == "" ]; then
	cat<<EOF
********************************************************************************
                                     ERRORE
********************************************************************************
 L'editor di testi NANO non e' stato trovato e, dato che e' l'unico
previsto da questa procedura, non sara' possibile continuare con la
modifica della MACRO creata.

 Tuttavia sara' possibile procedere manualmente, tramite il proprio
editor di testi preferito, alla modifica del file:

	${HOME}/.xchat2/buduscript/${macro_name}.mcr

 In tutti i casi, il comando sara' aggiunto al menu BuDuScRiPt .

********************************************************************************
Premi INVIO per continuare
EOF
	read
    else
	nano ${HOME}/.xchat2/buduscript/${macro_name}.mcr
    fi
}

make_macro() {
    clear
    cat<<EOF
********************************************************************************
 Una MACRO e' composta da una sequenza di comandi IRC, scritti
esattamente allo stesso modo di quando li si digita al prompt di
XChat, come ad esempio:

	/SAY Ciao pincopallino, ora ti do OP !
	/OP pincopallino

 La peculiarita' delle MACRO sta nella possibilita' di spacificare dei
parametri, quindi ad esempio potremmo avere una macro di nome "opuser"
scritta cosi':

	/SAY Ciao \$1, ora ti do OP !
	/OP \$1

che, lanciata in questo modo:

	/budus macro opuser pincopallino

eseguirebbe proprio i due comandi menzionati all'inizio, come ci si aspetta.

Premi INVIO per continuare
********************************************************************************
EOF
    read
    clear
    cat<<EOF
********************************************************************************
 E' possibile specificare fino a 9 parametri, ovvero: \$1, \$2, \$3, \$4, \$5, \$6, 
                                                      \$7, \$8, \$9

 Il parametro \$0 rappresenta l'intera riga scritta al prompt di
XChat. Se si desidera ottenere un parametro partendo da una certa
posizione fino alla fine, si puo' usare il carattere '-' in questo
modo:

	/SAY Ciao \$1: \$2-

cosi' che scrivendo:

	/budus macro welcome pincopallino Entra se vuoi esci se puoi !

otterremo:

	/SAY Ciao pincopallino: Entra se vuoi esci se puoi !

Premi INVIO per continuare
********************************************************************************
EOF
    read
    clear
    cat<<EOF
********************************************************************************
 Facendo iniziare una riga con il carattere '#', questa verra' ignorata; e'
cosi' possibile inserire commenti o "inibire" comandi senza cancellarli, ex:

	# Questa macro serve per salutare un amico
	/SAY Ciao \$1 !
	#/KICK \$1 ... pero' ora sparisci ! (LOL)

 Dato che le MACRO vengono eseguite rispettando i parametri anti-flood, nel
caso in cui si desidera che non vengano eseguiti con questa restrizione, si
puo' utilizzare la direttiva '#fastflush', in questo modo:

	#fastflush
	# Questa macro serve per salutare un amico
	/SAY Ciao \$1 !

 Per integrare meglio una MACRO nel Menu creato da BuDuScRiPt (viene aggiunta
in automatico) e' possibile usare in testa al file questi commenti speciali:

	# Macro: descrizione della macro
	# USE: /budus macro nomemacro <param_obbligatorio> [param_facoltativo]

Premi INVIO per continuare
********************************************************************************
EOF
    read
    read_macro_name
    clear
    cat<<EOF
********************************************************************************
 Ora verra' aperto un editor di testo (NANO) che ti consentira' di scrivere cio'
che la macro deve eseguire quando viene lanciata.

 In basso troverai un elenco dei comandi che puoi usare, come ad esempio:

^G Guida     ^O Salva     ^R Inserisci ^Y Pag Prec. ^K Taglia    ^C Posizione
^X Esci      ^J Giustifica^W Cerca     ^V Pag Succ. ^U Incolla   ^T Ortografia

 Il carattere ^ significa che va premuto il tasto Control (CTRL) della tastiera;
quindi, ad esempio per uscire, bisogna premere CTRL+x, per salvare CTRL+o e
cosi' via.

 Ricorda che una MACRO e' semplicemente una sequenza di comandi IRC/BuDuScRiPt
parametrizzati, praticamente immagina di scrivere gli stessi comandi che daresti
in XChat ma, al posto di un nickname, devi usare una variabile (ex: \$1).

 L'elenco dei comandi IRC lo ottieni con /help , mentre quelli di BuDuScRiPt
con /budus e con /event .

Premi INVIO per continuare
********************************************************************************
EOF
    read
    cat<<EOF > ${HOME}/.xchat2/buduscript/${macro_name}.mcr
#fastflush
# Macro: descrizione della macro
# USE: /budus macro ${macro_name} <param_obbligatorio> [param_facoltativo]
# Example: /SAY Hello \$1
EOF
    read_editor
    clear

    cat<<EOF
********************************************************************************
                              MACRO Risultante
********************************************************************************
EOF
    
    cat ${HOME}/.xchat2/buduscript/${macro_name}.mcr
    
    cat<<EOF
********************************************************************************

Vuoi salvarla in BuDuScRiPt ? (S/n)
EOF
    read salvataggio
    if [ "${salvataggio}" == "s" ] || [ "${salvataggio}" == "S" ] || [ "${salvataggio}" == "" ]; then
	macro_data=$(cat $HOME/.xchat2/buduscript/${macro_name}.mcr\
	    | grep -e "# Macro:" -e "# USE:"\
	    | sed s@#\ Macro:@\ -@g\
	    | tr '\n' ' '\
	    | sed s@#\ USE:\ /budus\ macro\ @-\ @g\
	    | sed s/$/\\n/g)
	
	echo "/MENU ADD \"BuDuScRiPt/MACRO/${macro_name}${macro_data}\" \"budus InsertInBuffer() /budus macro ${macro_name}\"" > /tmp/buduscript_macro.dat
    else
	rm ${HOME}/.xchat2/buduscript/${macro_name}.mcr
    fi
}

if [ ! -d /tmp ]; then
    echo "/ECHO ERRORE: Impossibile procedere senza la cartella /tmp !"
    
    exit 1;
fi

if [ "$1" == "callback" ]; then
    if [ -f /tmp/buduscript_macro.dat ]; then
	echo "/ECHO Caricamento della nuova MACRO ..."
	
	cat /tmp/buduscript_macro.dat
	
	echo "/ECHO ... Fatto !"
	echo "La trovi nel menu %BBuDuScRiPt -> MACRO"
	rm -f /tmp/buduscript_macro.dat
	rm -f /tmp/buduscript_macro.lck
	
	exit 0;
    elif [ -f /tmp/buduscript_macro.del ]; then
	echo "/ECHO Creazione macro abortita."
	
	rm -f /tmp/buduscript_macro.del
	rm -f /tmp/buduscript_macro.lck
    elif [ -f /tmp/buduscript_macro.lck ]; then
	echo "/TIMER -refnum 2255 3 budus pipe_script_silent $HOME/.xchat2/buduscript/buduscript_script__macro_add.sh callback"
    else
	echo "/ECHO Creazione Macro rimasta in sospeso, terminata ora !"
	
	exit 1;
    fi
elif [ "$1" == "makemacro" ]; then
    # CREAZIONE DELLA MACRO
    make_macro
    
    if [ ! -f /tmp/buduscript_macro.dat ]; then
	touch /tmp/buduscript_macro.del
    fi
    
    exit 0;
else
    if [ ! -f /tmp/buduscript_macro.lck ]; then
	touch /tmp/buduscript_macro.lck
	if [ ! -f /tmp/buduscript_macro.lck ]; then
	    echo "/ECHO ERRORE: Impossibile procedere senza permesso in scrittura nella cartella /tmp !"
	    
	    exit 1;
	fi
	
	echo "/exec xterm -e \"$0 makemacro\" &"
	echo "/TIMER -refnum 2255 3 budus pipe_script_silent $HOME/.xchat2/buduscript/buduscript_script__macro_add.sh callback"
    else
	echo "/ECHO AVVERTIMENTO: Non e' possibile creare piu' Macro contemporaneamente, finire l'altro processo."
	echo "/ECHO               Se l'altro processo e' stato chiuso in modo anomalo, rilanciare questo comando."
	
	rm -f /tmp/buduscript_macro.lck
    fi    
fi
