#!/bin/bash

# Version 23/12/2010
# $Revision: 1.8 $
# UDA'Software 2010

# Questo script serve per inviare un comando in modo massivo.

database_file=${2-${1}}
lock_file=$HOME/.xchat2/buduscript/massive.lck
macro_name=massive_temp_macro
macro_file=$HOME/.xchat2/buduscript/${macro_name}.mcr

# ##############################################################################
################################################################################
# FUNZIONI
################################################################################
print_database() {
    {
	item_number=$(echo "${database_sorted}" | grep -v ^$ | wc -l)
	
	[ ${flag_debug_mode:-0} == 1 ] && printf '[XX] DB RECORD = %d\n' $(echo "${database_sorted}" | wc -l)
	
	printf "Intercettati ${item_number} Utenti.\n"
	echo "${option_selected}"
	echo "Premi 'q' per Uscire (Quit); i tasti freccia o pagina SU e GIU per spostarti."
	for item in ${database_sorted}; do
	    server=$(echo "${item}" | awk -F'\t' '{print $1}')
	    channel=$(echo "${item}" | awk -F'\t' '{print $2}')
	    nickname=$(echo "${item}" | awk -F'\t' '{print $3}')
	    modes=$(echo "${item}" | awk -F'\t' '{print $4}' | sed s/\ :.*//)
	    ignored=$(echo "${item}" | awk -F'\t' '{print $5}' | sed s/0/UNIGNORED/ | sed s/1/IGNORED/)
	    local=$(echo "${item}" | awk -F'\t' '{print $6}' | sed s/0/REMOTE/ | sed s/1/LOCAL/)
	    
	    if [ "${server}" != "${last_server}" ]; then
		last_server=${server}
		printf "* SERVER: ${server}\n"
	    fi
	    if [ "${channel}" != "${last_channel}" ]; then
		last_channel=${channel}
		printf "|\_ CHANNEL: ${channel}\n"
	    fi
	    printf "|  \_ USER: %42s [%6s] %9s %6s\n" "${nickname}" "${modes}" "${ignored}" "${local}"
	done
	printf "\\______________________________________________________________________________/\n"
    } | less
}

################################################################################
make_database_filtered() {
    cp ${database_file} ${database_file}.tmp
    database_sorted=$(cat ${database_file}.tmp\
	| awk -F'\t' '{print $1"\t"$2"\t"$3"\t"$7"\t"$9"\t"$10}'\
	| sort\
	| grep -i "${4-.*}"'	'"${5-.*}"'	.*	.*'"${1}"'.*:[0-9].*	'"${2:-[0-1]}"'	'"${3:-[0-1]}")
    rm -f ${database_file}.tmp
    
    [ ${flag_debug_mode:-0} == 1 ] && printf '[01] DB RECORD = %d\n' $(echo "${database_sorted}" | wc -l)
    
    printf "Desideri applicare un filtro avanzato ? (y/N) "
    read advanced_filter
    if [ "${advanced_filter}" == "y" ] || [ "${advanced_filter}" == "Y" ]; then
	IFS=" "
	
	[ ${flag_debug_mode:-0} == 0 ] && clear
	echo "Lista dei servers collegati:"
	echo "${database_sorted}" | awk -F'\t' '{print $1}' | sort | uniq
	printf "Analizzare tutti i Server (se non usi 'y', elencali separandoli con spazio) ?   (Y/servername list) "
	read filtered_preferred_server
	if [ "${filtered_preferred_server}" != "" ] && [ "${filtered_preferred_server}" != "y" ] && [ "${filtered_preferred_server}" != "Y" ]; then
	    for server in ${filtered_preferred_server}; do
		if [ "${database_sorted_filtered}" == "" ]; then
		    database_sorted_filtered=$(echo "${database_sorted}" | grep -F "	${server}	")
		else
		    database_sorted_filtered=$(printf '%s\n%s\n' "${database_sorted_filtered}" "$(echo "${database_sorted}" | grep -F "	${server}	")")
		fi
	    done
	fi
	if [ "${database_sorted_filtered}" != "" ]; then database_sorted=${database_sorted_filtered} ; fi
	database_sorted_filtered=""
	
	[ ${flag_debug_mode:-0} == 1 ] && printf '[02] DB RECORD = %d\n' $(echo "${database_sorted}" | wc -l)
	
	[ ${flag_debug_mode:-0} == 0 ] && clear
	echo "Lista dei canali collegati:"
	echo "${database_sorted}"\
		| awk -F'\t' '{print $2}'\
		| sort\
		| uniq
	printf "Analizzare tutti i Canali (se non usi 'y', elencali separandoli con spazio) ?   (Y/#channelname list) "
	read filtered_preferred_channel
	if [ "${filtered_preferred_channel}" != "" ] && [ "${filtered_preferred_channel}" != "y" ] && [ "${filtered_preferred_channel}" != "Y" ]; then
	    for channel in ${filtered_preferred_channel}; do
		if [ "${database_sorted_filtered}" == "" ]; then
		    database_sorted_filtered=$(echo "${database_sorted}" | grep -F "	${channel}	")
		else
		    database_sorted_filtered=$(printf '%s\n%s\n' "${database_sorted_filtered}" "$(echo "${database_sorted}" | grep -F "	${channel}	")")
		fi
	    done
	fi
	if [ "${database_sorted_filtered}" != "" ]; then database_sorted=${database_sorted_filtered} ; fi
	database_sorted_filtered=""
	
	IFS=$'\n'
	
	if [ "${filtered_preferred_channel}" == "" ]; then
	    filtered_preferred_channel=$(echo "${database_sorted}" \
		| awk -F'\t' '{print $2}' \
		| sort \
		| uniq)
	else
	    filtered_preferred_channel=$(echo "${filtered_preferred_channel}" | tr ' ' '\n')
	fi
	
	[ ${flag_debug_mode:-0} == 1 ] && printf '[02] DB RECORD = %d\n' $(echo "${database_sorted}" | wc -l)
	
	[ ${flag_debug_mode:-0} == 0 ] && clear
	if [ $(echo "${filtered_preferred_channel}" | wc -l) -gt 1 ]; then
	    printf 'Comuni   = Utenti presenti in piu'\'' canali.\n'
	    printf 'Diversi  = Utenti presenti in un solo canale.\n'
	    printf 'Univoci  = Ogni utente elencato non piu'\'' di una volta.\n'
	    printf 'Presenti = Elenco degli utenti presenti nei rispettivi canali.\n'
	    printf "\nIndividuare solo gli utenti Comuni, Diversi, Univoci o Presenti ? (C/d/u/p) "
	    read filtered_preferred_users
	    if [ "${filtered_preferred_users}" == "p" ] || [ "${filtered_preferred_users}" == "P" ]; then
		# PRESENTI
		user_list_filtered=
	    elif [ "${filtered_preferred_users}" == "u" ] || [ "${filtered_preferred_users}" == "U" ]; then
		# UNIVOCI
		user_list_filtered=$(echo "${database_sorted}" \
		    | awk -F'\t' '{print $3}' \
		    | sort \
		    | uniq)
	    elif [ "${filtered_preferred_users}" == "d" ] || [ "${filtered_preferred_users}" == "D" ]; then
		# DIVERSI
		user_list_filtered=$(echo "${database_sorted}" \
		    | awk -F'\t' '{print $3}' \
		    | sort \
		    | uniq -u)
	    else
		# COMUNI
		user_list_filtered=$(echo "${database_sorted}" \
		    | awk -F'\t' '{print $3}' \
		    | sort \
		    | uniq -d)
		
		if [ $(echo "${filtered_preferred_channel}" | wc -l) -gt 2 ]; then
		    printf "Mantenere utenti effettivamente presenti in tutti i canali del filtro ? (y/N) "
		    read channel_present_users
		    if [ "${channel_present_users}" == "y" ] || [ "${channel_present_users}" == "Y" ]; then
			user_list_filtered_tmp=$(echo "${user_list_filtered}" | sed 's@^@ @' | sed 's@$@ @')
			for user in ${user_list_filtered}; do
			    for channel in ${filtered_preferred_channel}; do
				find_user=$(echo "${database_sorted}" | grep -F "	${channel}	${user}	")
				
				if [ "${find_user}" == "" ]; then
				    user_list_filtered_tmp=$(echo "${user_list_filtered_tmp}" | grep -vF " ${user} ")
				fi
			    done
			done
			user_list_filtered="${user_list_filtered_tmp}"
		    fi
		fi
		
		printf "Mantenere copie multiple degli utenti (elencati piu' volte per canale) ? (y/N) "
		read multiple_copies_users
	    fi
	fi
	
	for user in ${user_list_filtered}; do
	    user=$(echo "${user}" | sed 's@^ @@' | sed 's@ $@@')
	    
	    if [ "${database_sorted_filtered}" == "" ]; then
		if [ "${multiple_copies_users}" == "y" ] || [ "${multiple_copies_users}" == "Y" ]; then
		    database_sorted_filtered=$(echo "${database_sorted}" | grep -F "	${user}	")
		else
		    database_sorted_filtered=$(echo "${database_sorted}" | grep -F "	${user}	" | head -n1)
		fi
	    else
		if [ "${multiple_copies_users}" == "y" ] || [ "${multiple_copies_users}" == "Y" ]; then
		    database_sorted_filtered=$(printf '%s\n%s\n' "${database_sorted_filtered}" "$(echo "${database_sorted}" | grep -F "	${user}	")")
		else
		    database_sorted_filtered=$(printf '%s\n%s\n' "${database_sorted_filtered}" "$(echo "${database_sorted}" | grep -F "	${user}	" | head -n1)")
		fi
	    fi
	done
	
	if [ "${database_sorted_filtered}" != "" ]; then database_sorted=${database_sorted_filtered} ; fi
	database_sorted_filtered=""
	
	[ ${flag_debug_mode:-0} == 1 ] && printf '[03] DB RECORD = %d\n' $(echo "${database_sorted}" | wc -l)
	
	printf "Inserisci una stringa pattern per filtrare il risultato (INVIO per nessuno) ?   "
	read pattern_filter

	[ "${pattern_filter}" != "" ] && \
	    database_sorted=$(echo "${database_sorted}" | sort -k 2 | grep -iF "${pattern_filter}") || \
	    database_sorted=$(echo "${database_sorted}" | sort -k 2)
	
	[ ${flag_debug_mode:-0} == 1 ] && printf '[04] DB RECORD = %d\n' $(echo "${database_sorted}" | wc -l)
    fi
}

################################################################################
set_sending_flags() {
    printf "Inviare ${tipology} anche agli utenti IGNORATI ? (y/N) "
    read flag_ignored
    if [ "${flag_ignored}" == "y" ] || [ "${flag_ignored}" == "Y" ]; then
	flag_ignored=[0-1]
    else
	flag_ignored=0
    fi
    
    printf "Inviare ${tipology} anche all'utente LOCALE ? (y/N) "
    read flag_local
    if [ "${flag_local}" == "y" ] || [ "${flag_local}" == "Y" ]; then
	flag_local=[0-1]
    else
	flag_local=0
    fi

    if [ "${1}" != "away" ]; then
	printf "Inviare ${tipology} anche agli utenti AWAY ? (y/N) "
	read flag_away
	if [ "${flag_away}" == "y" ] || [ "${flag_away}" == "Y" ]; then
	    flag_away=""
	else
	    flag_away="H"
	fi
    fi
}

################################################################################
exec_multitype() {
    [ ${flag_debug_mode:-0} == 0 ] && clear
    cat<<EOF
Puoi utilizzare la parola chiave NICKNAME (rispetta il maiuscolo nello
scriverla) all'interno di quello che vai a digitare; lo script la
sostituira' con i nickname degli utenti che saranno oggetto
dell'azione di massa.
Se, anzich usare NICKNAME, si utilizza NICKNAMES (notare la S finale)
non sara' eseguito un ${tipology} per ogni utente, ma ne verra'
realizzato uno unico per ogni canale contenente una lista separata da
',' (virgola) di tutti i nickname del canale stesso (o meglio, quelli
risultanti dai criteri di ricerca impostati) laddove la parola chiave
stessa compare.
EOF
    if [ "${tipology}" == "COMANDO" ]; then
	echo "Ricordarsi di anteporre il carattere '/' quando si usano i comandi IRC."
	echo "Inserire il comando IRC/XChat/BuDuScRiPt da inviare:"
    else
	echo "Inserire il messaggio da inviare: "
    fi
    read user_string
    
    if [ "${user_string}" != "" ]; then
	if [ "${user_string/*NICKNAMES*/}" != "" ]; then
	    {
		echo "#fastflush"
		echo "# Temporary MACRO of massive command script."
		for item in ${database_sorted}; do
		    server=$(echo "${item}" | awk -F'\t' '{print $1}')
		    channel=$(echo "${item}" | awk -F'\t' '{print $2}')
		    nickname=$(echo "${item}" | awk -F'\t' '{print $3}')
		    
		    if [ "${tipology}" == "COMANDO" ]; then
			echo "/budus sendsess ${server}/${channel} ${user_string}"\
			    | sed s/NICKNAME/${nickname}/g
		    else
			echo "/budus sendsess ${server}/${channel} ${tipology} ${nickname} ${user_string}"\
			    | sed s/NICKNAME/${nickname}/g
		    fi
		done
		echo "/exec rm -f ${macro_file}"
	    } > ${macro_file}
	else
	    {
		server_list=$(echo "${database_sorted}"\
		    | awk -F'\t' '{print $1}'\
		    | sort\
		    | uniq\
		    | grep -v '[*]')
		for server in ${server_list}; do
		    channel_list=$(echo "${database_sorted}"\
			| grep -F "${server}	"\
			| awk -F'\t' '{print $2}'\
			| sort\
			| uniq\
			| grep -v '[*]')
		    for channel in ${channel_list}; do
			user_list=$(echo "${database_sorted}"\
			    | grep -F "${server}	${channel}"\
			    | awk -F'\t' '{print $3}'\
			    | sort\
			    | tr '\n' ','\
			    | sed s/,$/\\n/)
			if [ "${tipology}" == "COMANDO" ]; then
			    echo "/budus sendsess ${server}/${channel} ${user_string}"\
				| sed s/NICKNAMES/"${user_list}"/g
			else
			    echo "/budus sendsess ${server}/${channel} ${tipology} ${nickname} ${user_string}"\
				| sed s/NICKNAMES/"${user_list}"/g
			fi
		    done
		done
		echo "/exec rm -f ${macro_file}"
	    } > ${macro_file}
	fi
    else
	echo "Comando o Frase nulla non consentita. Premi INVIO per abortire."
	read
    fi
}

# ##############################################################################
################################################################################
# MAIN
################################################################################
if [ "${1}" == "AUTOCHECK" ]; then
    if [ ! -f "${lock_file}" ]; then
	if [ -f ${macro_file} ]; then
	    echo "/budus macro ${macro_name}"
	    echo "/ECHO %C3,1Procedura dei Comandi di Massa terminata."
	fi
    else
	echo "/budus dbsave \\"
	echo "/TIMER -refnum 2255 5 budus pipe_script_silent \"$HOME/.xchat2/buduscript/buduscript_script__massive_command.sh\" AUTOCHECK"
    fi
    
    exit 0;
fi

if [ "${1}" == "AUTORUN" ]; then
    if [ -f "${lock_file}" ]; then
	echo "/ECHO %C4,1ERRORE: Sembra che un'altra finestra come questa sia ancora attiva, oppure, non sia terminata correttamente."
	echo "/ECHO %C8,1Se non e' terminata correttamente, si puo' risolvere il problema eliminando il file con il comando: %C3,1%B/exec rm -vf ${lock_file}"
	
	exit 1;
    fi
    touch "${lock_file}"
    if [ ! -f "${lock_file}" ]; then
	echo "/ECHO %C4,1ERRORE: Impossibile lanciare la procedura di AUTORUN, probabile problema di permessi."
	
	exit 1;
    fi
    echo "/TIMER -refnum 2255 5 budus pipe_script_silent \"$HOME/.xchat2/buduscript/buduscript_script__massive_command.sh\" AUTOCHECK"
    echo "/exec xterm -e \"$HOME/.xchat2/buduscript/buduscript_script__massive_command.sh\" ${database_file}"
    
    exit 0;
fi

# ########## ########## ########## ########## ########## ########## ##########
# ########## ########## ##########   INIZIO   ########## ########## ##########
# ########## ########## ########## ########## ########## ########## ##########
if [ ! -f "${database_file}" ]; then
    if [ -f "${lock_file}" ]; then rm -f "${lock_file}"; fi
    echo "ERRORE GRAVE: Il database degli utenti (${database_file}) non e' stato trovato."
    echo "Premere INVIO per abortire."
    read

    exit 1;
fi

if [ "${1}" == "DEBUG" ]; then
    flag_debug_mode=1
fi

# ########## ########## ########## ########## ########## ########## ##########
IFS_OLD=${IFS}
IFS=$'\n'
COLUMNS=30
options_main="Esci dalla gestione dei comandi massivi
Legenda Caratteri delle Modalita' Utente
Elenco Utenti
Invio NOTICE di massa
Invio PRIVMSG di massa
Invio COMANDO di massa"

options_list="Ritorna al Menu Principale
Elenca TUTTI gli Utenti di TUTTI i Servers di TUTTI i Canali
Elenca Utenti IRCOP di TUTTI i Servers di TUTTI i Canali
Elenca Utenti FOUNDER di TUTTI i Servers di TUTTI i Canali
Elenca Utenti SOP di TUTTI i Servers di TUTTI i Canali
Elenca Utenti OP di TUTTI i Servers di TUTTI i Canali
Elenca Utenti HOP di TUTTI i Servers di TUTTI i Canali
Elenca Utenti VOP di TUTTI i Servers di TUTTI i Canali
Elenca Utenti AWAY di TUTTI i Servers di TUTTI i Canali
Elenca Utenti Registrati di TUTTI i Servers di TUTTI i Canali
Elenca Utenti Registrati del Server e del Canale specificato"

options_multitype="Ritorna al Menu Principale
Invia TIPOLOGY a TUTTI gli Utenti di TUTTI i Servers di TUTTI i Canali
Invia TIPOLOGY agli Utenti IRCOP di TUTTI i Servers di TUTTI i Canali
Invia TIPOLOGY agli Utenti FOUNDER di TUTTI i Servers di TUTTI i Canali
Invia TIPOLOGY agli Utenti SOP di TUTTI i Servers di TUTTI i Canali
Invia TIPOLOGY agli Utenti OP di TUTTI i Servers di TUTTI i Canali
Invia TIPOLOGY agli Utenti HOP di TUTTI i Servers di TUTTI i Canali
Invia TIPOLOGY agli Utenti VOP di TUTTI i Servers di TUTTI i Canali
Invia TIPOLOGY agli Utenti AWAY di TUTTI i Servers di TUTTI i Canali
Invia TIPOLOGY agli Utenti Registrati di TUTTI i Servers di TUTTI i Canali
Invia TIPOLOGY agli Utenti del Server e del Canale specificato"

options=${options_main}

last_server=""
last_channel=""

[ ${flag_debug_mode:-0} == 0 ] && clear
cat<<EOF
********************************************************************************
*                       MANAGER DEI COMANDI DI MASSA                           *
********************************************************************************
Questa procedura serve per eseguire dei comandi di massa, come l'invio di
messaggi o di comandi dinamici su tutti gli utenti presenti nei canali che si
frequenta (o una parte di essi, in base ai filtri messi a disposizione).

L'utilizzo sconsiderato di questo strumento puo' portare a misure punitive piu'
o meno pesanti a seconda del network coinvolto. Si consiglia quindi di farne un
uso MOLTO cauto, facendo attenzione a non infastidire gli altri utenti.

Prima di procedere all'invio di comandi o messaggi, sarebbe infatti opportuno
fare un po' di pratica con lo strumento che elenca gli utenti presenti nel
database, cosi' da farsi prima un'idea di quanti utenti potenzialmente si
possono coinvolgere.

Indipendentemente dalla voce di menu, viene comunque chiesto se si desidera
applicare un "filtro avanzato" che consente di filtrare la lista utenti
coinvolta nell'eleborazione, in modo da analizzare solo alcuni
server/canali/utenti.
********************************************************************************
Premi INVIO per continuare
EOF
read

while [ 1 == 1 ]; do
    [ ${flag_debug_mode:-0} == 0 ] && clear
    printf "Digita il numero corrispondente alla scelta e premi INVIO:\n\n"
    select option_selected in ${options}; do
	if [ "${option_selected}" == "Elenco Utenti" ]; then
	    options=${options_list}
	elif [ "${option_selected}" == "Legenda Caratteri delle Modalita' Utente" ]; then
	    cat<<EOF
Carattere > Significato

        * > IRC Operator
        ~ > Channel Founder
        & > Channel Super Operator
        @ > Channel Operator
        % > Channel Half Operator
        + > Channel Voice Operator
        H > User Here (Utente presente, non in modalita' AWAY)
        G > User AWAY
        B > BOT (software di servizio IRC)
        S > SSL (Connessione sicura SSL)
        r > User Registered (Utente registrato e Identificato)

EOF
	    echo "Premi INVIO per continuare"
	    read
	elif [ "${option_selected}" == "Invio NOTICE di massa" ]; then
	    tipology=NOTICE
	    options=$(echo "${options_multitype}" | sed s/TIPOLOGY/${tipology}/g)
	elif [ "${option_selected}" == "Invio PRIVMSG di massa" ]; then
	    tipology=PRIVMSG
	    options=$(echo "${options_multitype}" | sed s/TIPOLOGY/${tipology}/g)
	elif [ "${option_selected}" == "Invio COMANDO di massa" ]; then
	    tipology=COMANDO
	    options=$(echo "${options_multitype}" | sed s/TIPOLOGY/${tipology}/g)
	elif [ "${option_selected}" == "Elenca TUTTI gli Utenti di TUTTI i Servers di TUTTI i Canali" ]; then
	    make_database_filtered
	    print_database
	elif [ "${option_selected}" == "Elenca Utenti IRCOP di TUTTI i Servers di TUTTI i Canali" ]; then
	    make_database_filtered "\*"
	    print_database
	elif [ "${option_selected}" == "Elenca Utenti FOUNDER di TUTTI i Servers di TUTTI i Canali" ]; then
	    make_database_filtered "~"
	    print_database
	elif [ "${option_selected}" == "Elenca Utenti SOP di TUTTI i Servers di TUTTI i Canali" ]; then
	    make_database_filtered "&"
	    print_database
	elif [ "${option_selected}" == "Elenca Utenti OP di TUTTI i Servers di TUTTI i Canali" ]; then
	    make_database_filtered "@"
	    print_database
	elif [ "${option_selected}" == "Elenca Utenti HOP di TUTTI i Servers di TUTTI i Canali" ]; then
	    make_database_filtered "%"
	    print_database
	elif [ "${option_selected}" == "Elenca Utenti VOP di TUTTI i Servers di TUTTI i Canali" ]; then
	    make_database_filtered "+"
	    print_database
	elif [ "${option_selected}" == "Elenca Utenti AWAY di TUTTI i Servers di TUTTI i Canali" ]; then
	    make_database_filtered "G"
	    print_database
	elif [ "${option_selected}" == "Elenca Utenti Registrati di TUTTI i Servers di TUTTI i Canali" ]; then
	    make_database_filtered "r"
	    print_database
	elif [ "${option_selected}" == "Elenca Utenti Registrati del Server e del Canale specificato" ]; then
	    tipology="richiesta elenco"
	    make_database_filtered
	    [ ${flag_debug_mode:-0} == 0 ] && clear
	    echo "Lista dei servers collegati:"
	    echo "${database_sorted}" | awk -F'\t' '{print $1}' | sort | uniq
	    printf "Elencare tutti i Server ? (Y/servername) "
	    read preferred_server
	    if [ "${preferred_server}" == "" ]; then
		preferred_server=".*"
	    fi
	    
	    [ ${flag_debug_mode:-0} == 0 ] && clear
	    echo "Lista dei canali collegati:"
	    echo "${database_sorted}"\
		| awk -F'\t' '{print $1"\t"$2}'\
		| grep "^${preferred_server}	"\
		| awk -F'\t' '{print $2}'\
		| sort\
		| uniq
	    printf "Elencare tutti i Canali ? (Y/#channelname) "
	    read preferred_channel
	    if [ "${preferred_channel}" == "" ]; then
		preferred_channel=".*"
	    fi
	    
	    [ ${flag_debug_mode:-0} == 0 ] && clear
	    cat<<EOF

Legenda dei caratteri identificativi degli User Modes:
 * > IRC OP
 ~ > FOUNDER
 & > SOP
 @ > OP
 % > HOP
 + > VOP
 B > BOT
 S > SSL
 r > Registered
********************************************************************************
EOF
    printf "Elencare tutti gli Utenti ? (Y/*~&@%%+BSr) "
	    read preferred_user
	    if [ "${preferred_user}" == "" ]; then
		preferred_user=""
	    else
		preferred_user="[${preferred_user/\*/\\*}]"
	    fi
	    
	    set_sending_flags
	    if [ "${flag_away}" == "" ] && [ "${preferred_user}" == "" ]; then
		flag_modes=""
	    else
		flag_modes="${flag_away}.*${preferred_user}"
	    fi
	    
	    make_database_filtered "${flag_modes}" "${flag_ignored}" "${flag_local}" "${preferred_server}" "${preferred_channel}"
	    print_database
	elif [ "${option_selected}" == "Invia ${tipology} a TUTTI gli Utenti di TUTTI i Servers di TUTTI i Canali" ]; then
	    set_sending_flags
	    make_database_filtered "${flag_away}" "${flag_ignored}" "${flag_local}"
	    exec_multitype
	    print_database
	elif [ "${option_selected}" == "Invia ${tipology} agli Utenti IRCOP di TUTTI i Servers di TUTTI i Canali" ]; then
	    set_sending_flags
	    make_database_filtered "${flag_away}.*[\*]" "${flag_ignored}" "${flag_local}"
	    exec_multitype
	    print_database
	elif [ "${option_selected}" == "Invia ${tipology} agli Utenti FOUNDER di TUTTI i Servers di TUTTI i Canali" ]; then
	    set_sending_flags
	    make_database_filtered "${flag_away}.*[~]" "${flag_ignored}" "${flag_local}"
	    exec_multitype
	    print_database
	elif [ "${option_selected}" == "Invia ${tipology} agli Utenti SOP di TUTTI i Servers di TUTTI i Canali" ]; then
	    set_sending_flags
	    make_database_filtered "${flag_away}.*[&]" "${flag_ignored}" "${flag_local}"
	    exec_multitype
	    print_database
	elif [ "${option_selected}" == "Invia ${tipology} agli Utenti OP di TUTTI i Servers di TUTTI i Canali" ]; then
	    set_sending_flags
	    make_database_filtered "${flag_away}.*[@]" "${flag_ignored}" "${flag_local}"
	    exec_multitype
	    print_database
	elif [ "${option_selected}" == "Invia ${tipology} agli Utenti HOP di TUTTI i Servers di TUTTI i Canali" ]; then
	    set_sending_flags
	    make_database_filtered "${flag_away}.*[%]" "${flag_ignored}" "${flag_local}"
	    exec_multitype
	    print_database
	elif [ "${option_selected}" == "Invia ${tipology} agli Utenti VOP di TUTTI i Servers di TUTTI i Canali" ]; then
	    set_sending_flags
	    make_database_filtered "${flag_away}.*[+]" "${flag_ignored}" "${flag_local}"
	    exec_multitype
	    print_database
	elif [ "${option_selected}" == "Invia ${tipology} agli Utenti AWAY di TUTTI i Servers di TUTTI i Canali" ]; then
	    set_sending_flags "away"
	    make_database_filtered "G" "${flag_ignored}" "${flag_local}"
	    exec_multitype
	    print_database
	elif [ "${option_selected}" == "Invia ${tipology} agli Utenti Registrati di TUTTI i Servers di TUTTI i Canali" ]; then
	    set_sending_flags
	    make_database_filtered "${flag_away}.*[r]" "${flag_ignored}" "${flag_local}"
	    exec_multitype
	    print_database
	elif [ "${option_selected}" == "Invia ${tipology} agli Utenti del Server e del Canale specificato" ]; then
	    [ ${flag_debug_mode:-0} == 0 ] && clear
	    cat<<EOF
Hai selezionato l'opzione che ti consente di selezionare con precisione il
target del comando.

Dovrai specificare nell'ordine:
- se vuoi inviare a tutti i servers o solo ad uno specifico (in questo caso
  dovrai scriverne per intero il nome, ex: irc.mioserver.net)
- se vuoi inviare a tutti i canali o solo ad uno specifico (in questo caso
  dovrai scriverne per intero il nome, ex: #miocanale)
- se vuoi inviare a tutti gli utenti o solo ad alcuni (ad esempio solo agli
  operatori, solo agli HOP, ecc...)
- se vuoi inviare anche agli utenti ignorati
- se vuoi inviare anche agli utenti away
- se vuoi inviare anche all'utente locale

Per quanto riguarda server e canale e' ammesso uno solo di entrambi, oppure
tutti, non e' possibile specificarne solo alcuni (salvo non venga usato
il filtro avanzato).

Gli utenti invece possono essere selezionati in base a piu' modalita', ad
esempio tutti i FOUNDER, gli SOP e gli OP, ecc...

Premi INVIO per continuare.
EOF
	    make_database_filtered
	    read
	    
	    [ ${flag_debug_mode:-0} == 0 ] && clear
	    echo "Lista dei servers collegati:"
	    echo "${database_sorted}"\
		| awk -F'\t' '{print $1}'\
		| sort\
		| uniq\
		| grep -v '[*]'
	    printf "Inviare ${tipology} a tutti i Server ? (Y/servername) "
	    read preferred_server
	    if [ "${preferred_server}" == "" ]; then
		preferred_server=".*"
	    fi
	    
	    [ ${flag_debug_mode:-0} == 0 ] && clear
	    echo "Lista dei canali collegati:"
	    echo "${database_sorted}"\
		| awk -F'\t' '{print $1"\t"$2}'\
		| grep "^${preferred_server}	"\
		| awk -F'\t' '{print $2}'\
		| sort\
		| uniq\
		| grep -v '[*]'
	    printf "Inviare ${tipology} a tutti i Canali ? (Y/#channelname) "
	    read preferred_channel
	    if [ "${preferred_channel}" == "" ]; then
		preferred_channel=".*"
	    fi
	    
	    [ ${flag_debug_mode:-0} == 0 ] && clear
	    cat<<EOF

Legenda dei caratteri identificativi degli User Modes:
 * > IRC OP
 ~ > FOUNDER
 & > SOP
 @ > OP
 % > HOP
 + > VOP
 B > BOT
 S > SSL
 r > Registered
********************************************************************************
EOF
	    printf "Inviare ${tipology} a tutti gli Utenti ? (Y/*~&@%%+BSr) "
	    read preferred_user
	    if [ "${preferred_user}" == "" ]; then
		preferred_user=""
	    else
		preferred_user="[${preferred_user/\*/\\*}]"
	    fi
	    
	    set_sending_flags
	    if [ "${flag_away}" == "" ] && [ "${preferred_user}" == "" ]; then
		flag_modes=""
	    else
		flag_modes="${flag_away}.*${preferred_user}"
	    fi
	    
	    make_database_filtered "${flag_modes}" "${flag_ignored}" "${flag_local}" "${preferred_server}" "${preferred_channel}"
	    exec_multitype
	    print_database
	elif [ "${option_selected}" == "Ritorna al Menu Principale" ]; then
	    options=${options_main}
	elif [ "${option_selected}" == "Esci dalla gestione dei comandi massivi" ]; then	    
	    IFS=${IFS_OLD}
	    if [ -f "${lock_file}" ]; then rm -f "${lock_file}"; fi
	    exit 0;
	fi
	break;
    done
    if [ -f ${macro_file} ]; then
	if [ -f "${lock_file}" ]; then rm -f "${lock_file}"; fi
	break;
    fi
done

IFS=${IFS_OLD}
